// Copyright (c) 2020, the Dart project authors. Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

import 'dart:async';

import 'package:test/test.dart';
import 'package:vm_service/vm_service.dart';


void main() {
  test('Call dispose handler before onDone completion', () async {
    final completer = Completer<void>();
    final controller = StreamController<String>();
    bool completed = false;
    final fakeService = VmService(
        controller.stream,
        controller.sink.add,
        disposeHandler: () async {
           completed = true;
        });

    fakeService.dispose();
    await fakeService.onDone;
    expect(completed, true);
  });
}
